  x|  x|  x|  x|  x|  x|  x|  x|  x|  x|
; Simple Sinescroller! No (c)ode by aLpHa oNe!
; ============================================

	section	flashtro,code_c

	move.l 4.w,a6		; Get base of exec lib
	jsr -132(a6)		; Forbid Multitasking
	lea gfxlib(pc),a1	; Adress of gfxlib string to a1
	jsr -408(a6)		; Call OpenLibrary()
	move.l d0,gfxbase	; Save base of graphics.library
	move.l $6c.w,out+2	; Save old interruptptr
	move.l #newirq,$6c.w	; Set new interruptroutine
	move.l #cop,$dff080	; Set new copperlist

mouse:	btst #6,$bfe001		; Only a mouseloop here, all neccessary
	bne.b mouse		; stuff is handled in new interrupt routine

	move.l 4.w,a6		; Get base of exec lib
	move.l out+2(pc),$6c.w	; Restore old interruptptr
	move.l gfxbase(pc),a1	; Base of graphics.library to a1
	move.l 38(a1),$dff080	; Restore old copperlist
	jsr -414(a6)		; Call CloseLibrary()
	jsr -138(a6)		; Permit Multitasking
	moveq #0,d0		; Over..
	rts			; and out!

;-------------------------------------------------------------------------
newirq:	movem.l d0-a6,-(a7)	; Save registers

	lea $dff000,a6		; Customchipbase to a5

	move.l curpl(pc),a0	; Double Buffering
	move.l curpl+4(pc),a1	
	exg.l a0,a1		
	move.l a0,curpl
	move.l a1,curpl+4	

	move.l a0,d0		; Get address of actual bitplane
	move.w d0,bplptr+6	; ...and set up bitplaneregs in copperlist
	swap d0			;
	move.w d0,bplptr+2	;

wbl:	btst #14,$2(a6)		; Use blitter to clear bitplane
	bne.b wbl		
	move.l #$01000000,$40(a6)
	move.l #$0,$64(a6)
	move.l a1,$dff054
	move.w #256*64+20,$dff058
	
	subq.b #1,scrdelay		; Already scrolled a full char?
	bne.b scroll			; No, keep on scrolling
	move.b #16,scrdelay		; Otherwise set counter to 16
	move.l textptr(pc),a0		; Get Pointer to current textletter
	bsr.w print			; Print the letter
	addq.l #1,textptr		; Increase Textptr to next letter
scroll:	btst #14,$2(a6)			; Blitter ready to work?
	bne.b scroll			; No, keep on waiting
	move.l #scrpl,$50(a6)		; Source
	move.l #scrpl-2,$54(a6)		; Destination
	move.l #$f9f00000,$40(a6)	; Set Blittercontrolreg	
	move.w #$ffff,$44(a6)		; Maskbits
	move.l #$0,$64(a6)		; Modulo
	move.w #16*64+25,$58(a6)	; Scroll a range of 16 x 400 pixels




	lea sine(pc),a5
	add.l sineadd(pc),a5
	cmp.l #sineend,a5
	bne.b main
	lea sine(pc),a5
	move.l #0,sineadd

main:	moveq #21-1,d7
	lea scrpl(pc),a0
	move.l curpl+4(pc),a1
	add.l #4,a1

sinesc:	move.w #$c000,d3
	moveq #8-1,d6


wblit:	btst #14,$2(a6)			; Blitter ready to work?
	bne.b wblit			; No, keep on waiting
	move.l a1,a2
	add.l (a5)+,a2
	cmp.l #sineend,a5
	bne.b sineok
	lea sine(pc),a5
	
sineok:	move.l a0,$50(a6)		; Source A
	move.l a2,$4c(a6)		; Source B
	move.l a2,$54(a6)		; Destination D
	move.l #$0dfc0000,$40(a6)	; Set Blittercontrolreg
	move.w d3,$44(a6)		; Maskbits
	move.w #48,$62(a6)		; Modulo Source B
	move.w #48,$64(a6)		; Modulo Source A
	move.w #48,$66(a6)		; Modulo Destination D
	move.w #16*64+1,$58(a6)		; Scroll a range of 16 x 400 pixels
	ror.w #2,d3
	dbf d6,wblit

	addq.l #2,a0
	addq.l #2,a1
	dbf d7,sinesc

	add.l #16,sineadd

	movem.l (a7)+,d0-a6	; Restore registers
out:	jmp	$00000000	; Continue standard interrupt routine
;-------------------------------------------------------------------------

; Routine which prints one single letter to a fixed point on bitplane.
; A0 = ptr to text

print:	move.b (a0),d3		; Get current letter
	tst.b d3		; End of text reached?
	bne.b noend		; Nah, continue
	move.l #text,textptr	; Otherwise set pointer to textstart again
	move.b text(pc),d3	; Get first letter
noend:	lea chartab(pc),a1	; Adress of chartab to a1
	moveq #0,d2		; Counter
search:	cmp.b (a1,d2),d3	; Find letter in chartab
	beq.b foundit		; Letter found? Go on...
	addq.l #1,d2		; ..else increase counter
	bra.b search		; and continue searching
foundit:lsl.l #1,d2		; counter*2 = correct offset to charbuffer
	lea chars(pc),a3	; Address of chars to a3
	add.l d2,a3		; + offset to correct letter
	lea scrpl+48(pc),a2	; Address of scrollplane + 48 (right side)
	moveq #15-1,d2		; Height of chars (-1 coz we use dbf loop)
copy:	move.w (a3),(a2)	; Copy the letter
	add.l #80,a3		; 
	add.l #50,a2		; 
	dbf d2,copy		;
	rts			; Return to where we came from ;)

; Stuff
; *****

cop:		dc.w	$0106,$0000,$01fc,$0000		; AGA compatible
		dc.w	$008e,$1a63,$0090,$2cc1		; Setting up display,
		dc.w	$0092,$0020,$0094,$00d8		; modulo and so on
		dc.w	$0102,$0000,$0104,$0000
		dc.w	$0106,$0000,$0108,$0002
		dc.w	$0120,$0000,$0122,$0000		; Clear spriteptrs
		dc.w	$0124,$0000,$0126,$0000
		dc.w	$0128,$0000,$012a,$0000
		dc.w	$012c,$0000,$012e,$0000
		dc.w	$0130,$0000,$0132,$0000
		dc.w	$0134,$0000,$0136,$0000
		dc.w	$0138,$0000,$013a,$0000
		dc.w	$013c,$0000,$013e,$0000
		dc.w	$0100,$0200			; No Bitplane
		dc.w	$0180,$0000,$0182,$045a		; Color0 & Color1
		dc.w	$500f,$fffe,$0100,$1200		; 1 Bpl
bplptr:		dc.w	$00e0,$0000,$00e2,$0000		; Adress of bpl


		dc.w	$700f,$fffe,$0182,$056b
		dc.w	$750f,$fffe,$0182,$067c
		dc.w	$7a0f,$fffe,$0182,$078d
		dc.w	$800f,$fffe,$0182,$089e
		dc.w	$850f,$fffe,$0182,$09af
		dc.w	$8a0f,$fffe,$0182,$0abf
		dc.w	$900f,$fffe,$0182,$0bcf
		dc.w	$950f,$fffe,$0182,$0cdf
		dc.w	$9a0f,$fffe,$0182,$0def
		dc.w	$a00f,$fffe,$0182,$0fff

		dc.w	$a50f,$fffe,$0182,$0def
		dc.w	$aa0f,$fffe,$0182,$0cdf
		dc.w	$b00f,$fffe,$0182,$0bcf
		dc.w	$b50f,$fffe,$0182,$0abf
		dc.w	$ba0f,$fffe,$0182,$09af
		dc.w	$c00f,$fffe,$0182,$089e
		dc.w	$c50f,$fffe,$0182,$078d
		dc.w	$ca0f,$fffe,$0182,$067c
		dc.w	$d00f,$fffe,$0182,$056b
		dc.w	$d50f,$fffe,$0182,$045a



		dc.w $ff0f,$fffe,$0108,-98
	  dc.w $0180,$0004,$0182,$0008
		dc.w	$ffff,$fffe

scrdelay:	dc.b	16,0				; Scrollcounter

textptr:	dc.l	text				; Ptr to our text

text:		dc.b	"* flashtro.com * presents a "
		dc.b	"two-pixel sinescroll coded f"
		dc.b	"or the new tutorial sourceco"
		dc.b	"de section.                 "
		dc.b	0
		
		even

chartab: 	dc.b 	"abcdefghijklmnopqrstuvwxyz"	; chars as they appear
		dc.b 	"O<=>?#-./()*! "		; in our char table

chars:		incbin	"alpha:flashtro/chars.raw"

		blk.b	50,0				; Some spare bytes
scrpl:		blk.b	17*50,0				; Little bitplane 
							; only for standard
							; scroller, not visible
							; on screen


sineadd:	dc.l	0

sine:		incbin	"alpha:flashtro/sine"
sineend:

curpl:		dc.l plane1,plane2

plane1:		blk.b	256*50,0
plane2:		blk.b	256*50,0

gfxlib:		dc.b	"graphics.library",0,0

gfxbase:	dc.l	0
